searchNodes=[{"doc":"Listilled behaviour should be implemented by the modules (e.g. LiveView components) assuming the concern of their state-to-assigns transformation where such assigns then need to get compared and diffed (listilled) by the Listiller before getting actually assigned for the LiveComponent list rendering. This is to avoid updating (replacing) the appended (or prepended) container list with elements that haven't really changed which for LiveView is the default behavior when dealing with element lists. LiveComponent templates rendered by relying on the assigns constructed with this module need to take into account the :updated assign and interpret it according to the updated/0 docs. The same is also used in the Javascript element sorting code.","ref":"PhoenixLiveViewExt.Listilled.html","title":"PhoenixLiveViewExt.Listilled","type":"behaviour"},{"doc":"Returns the component id string representation of the provided element diff id.","ref":"PhoenixLiveViewExt.Listilled.html#c:component_id/1","title":"PhoenixLiveViewExt.Listilled.component_id/1","type":"callback"},{"doc":"Constructs component assigns from the provided model state.","ref":"PhoenixLiveViewExt.Listilled.html#c:construct_assigns/2","title":"PhoenixLiveViewExt.Listilled.construct_assigns/2","type":"callback"},{"doc":"Returns the list of all element diff ids along with the provided state with its last moment updates if any.","ref":"PhoenixLiveViewExt.Listilled.html#c:prepare_list/1","title":"PhoenixLiveViewExt.Listilled.prepare_list/1","type":"callback"},{"doc":"Checks if any distilling-relevant portion of the provided state has changed. This is an optional callback that, if defined, is invoked before distilling any assigns from the state. It should be defined to provide simple, comparison based checking as an alternative to constructing assigns if there are no changes in the state.","ref":"PhoenixLiveViewExt.Listilled.html#c:state_changed?/2","title":"PhoenixLiveViewExt.Listilled.state_changed?/2","type":"callback"},{"doc":"","ref":"PhoenixLiveViewExt.Listilled.html#t:assigns/0","title":"PhoenixLiveViewExt.Listilled.assigns/0","type":"type"},{"doc":"","ref":"PhoenixLiveViewExt.Listilled.html#t:state/0","title":"PhoenixLiveViewExt.Listilled.state/0","type":"type"},{"doc":":noop instructs of patching without sorting; intended for actual element updates or :full insertions (replacements) :delete instructs of rendering the marked-for-deletion variation of the LiveComponent element { :sort, dst_id :: String.t()} instructs of sorting the element i.e. inserting it before the provided destination dom id.","ref":"PhoenixLiveViewExt.Listilled.html#t:updated/0","title":"PhoenixLiveViewExt.Listilled.updated/0","type":"type"},{"doc":"Implements helper functions intended for use in LiveView and LiveComponent templates relying on Listilled assign lists.","ref":"PhoenixLiveViewExt.Listilled.Helpers.html","title":"PhoenixLiveViewExt.Listilled.Helpers","type":"module"},{"doc":"Returns container phx-update attribute string based on the type of list update.","ref":"PhoenixLiveViewExt.Listilled.Helpers.html#phx_update/1","title":"PhoenixLiveViewExt.Listilled.Helpers.phx_update/1","type":"function"},{"doc":"Returns the sort instruction string (or nil if sorting not required).","ref":"PhoenixLiveViewExt.Listilled.Helpers.html#updated_sort/1","title":"PhoenixLiveViewExt.Listilled.Helpers.updated_sort/1","type":"function"},{"doc":"Helps LiveView optimally insert, update and delete list elements with replacing the entire list only when absolutely necessary (i.e. when initialized). Transforms new state relative to the old one into a list of LiveComponent assigns so as to leave out the assigns for any listed component instances for which the new state does not result changed after the transformation. In other words, it diffs the list of LiveComponent assigns resulting from the state-to-assigns transformation (the components of which list are typically rendered as children of an appended or prepended container element). The purpose of Listiller is to allow for optimal implementation of appended/prepended container lists where only the list elements that have actually changed are sent from the server to the JS client over the wire and patched when client-side LiveView traverses the DOM elements. While this can be manually optimized for individual component instances by sending changes via LiveView.send_update/3 such an approach will not suffice in cases with multiple component changes and more importantly, in the cases where there are elements required for insertion to or deletion from the container list. The module relies on the reserved :updated key in the 'listilled' assigns, so developers need to make sure they don't use it for other purposes when constructing assigns in the PhoenixLiveViewExt.Listilled.construct_assigns/2 callback implementation. Below we use an example to explain step by step how to use Listiller. We do so on a non-trivial example of a table (two dimensions of components - the row components and the cell components nested in them). TableView example Our example relies on the following assumptions: TableLive module prepares the assigns for the corresponding table_live.html.leex template which lists all table rows. The assigns include a temporarily assigned list of rows to append/update that is mapped to :rows . The list contains only the rows that have actually changed and are to be treated as inserted, updated or deleted. RowComponent module prepares the assigns for the corresponding row_component_t.html.leex template which lists all cells in the row. Analogously, this involves the assigns used by the template itself as well as a temporarily assigned list of assigns for each cell that has actually changed (again, as in inserted, updated or deleted cells). We implement the CellComponent module and the corresponding cell_component.html_t.leex template to render table cells. The original state (the data model) that is held persistently assigned with TableLive is maintained in its domain-logic normalized form and both the temporary assigns for RowComponent and the ones for CellComponent are constructed dynamically. This is because any non-trivial real-life UC will most certainly not have its data kept optimally denormalized for the LiveView templates, while in the end the assigns need to be optimized for it is based on their diffing that the LiveView framework decides on what to send over the wire and what not. Since an appended container in LiveView can only have its elements updated or appended, the final changes are performed in JS when we are sure that LiveView has applied all the necessary patches. The finalization involves deletion of the marked-to-delete updated elements and sorting (repositioning) of the marked-to-sort appended elements. The first step is to write our TableLive module. Note that the :rows assigns have to be constructed and assigned every time the data may have possibly changed, involving all callbacks such as handle_info and handle_event . defmodule TableLive do use TableAppWeb , :live_view alias PhoenixLiveViewExt.Listiller # If relying on handle_params to initialize then the initialization should be done there instead. @impl true def mount ( _params , _session , socket ) do { :ok , initialize ( socket ) , temporary_assigns : [ rows : [ ] ] } end defp initialize ( socket ) do # passing an empty map to construct_rows to trigger a :full update, i.e. replacing the list construct_rows ( socket , %{ } ) end # handles events and optionally changes the state @impl true def handle_event ( event , payload , socket ) do { :noreply , socket |&gt; maybe_apply_changes ( event , payload ) |&gt; then ( &amp; &amp;1 . assigns . any_changes? &amp;&amp; construct_rows ( &amp;1 , socket . assigns ) || &amp;1 ) } end @impl true def handle_info ( event , socket ) do { :noreply , event |&gt; handle_server_response ( socket ) |&gt; construct_rows ( socket . assigns ) } end defp construct_rows ( socket , old_state ) do { rows , table_update } = Listiller . apply ( RowComponent , old_state , socket . assigns ) socket |&gt; assign ( :rows , rows ) |&gt; assign ( :table_update , table_update ) end end Next we make PhoenixLiveViewExt.Listilled.Helpers.phx_update/1 function available to our live view template.. defmodule TableView do use TableAppWeb , :view import PhoenixLiveViewExt.Listilled.Helpers , only : [ phx_update : 1 ] end .. and we make sure we properly render rows in our table_live.html.leex : .. &lt; div id = &quot;table&quot; phx - update = &quot;&lt;%= phx_update( @table_update) %&gt;&quot; phx - hook = &quot;TableHook&quot; &gt; &lt; % = for row_assigns &lt;- @rows do % &gt; &lt; % = live_component @socket , RowComponent , row_assigns % &gt; &lt; % end % &gt; &lt; / div &gt; &lt; div id = &quot;update-handler&quot; class = &quot;hidden&quot; data - print = &quot;&lt;%= update_print( assigns) %&gt;&quot; phx - hook = &quot;UpdateHook&quot; &gt; &lt; / div &gt; .. Note that we place the update-handler element after the table element in our template. This is because we need this element's updated callback invoked in JS after we are sure that all our components have been rendered by LiveView. As a reminder, LiveView will invoke updated callbacks starting with the table element and followed by each component recursively i.e. in the exact same order the elements get patched top down, and since there is no afterUpdated callback, we need this extra element with its own hook. And we need it updated when and if any listed component is updated. We assure the latter is true by invoking a function we pass the entire assigns map to so that LiveView cannot optimize and skip the update. The update_print/1 function here returns a pseudo random number encoded as a string and is out of the scope of this library. The point is having the UpdateHook 's updated callback invoked once all elements in the lists have been patched by LiveView. Now we provide the RowComponent module which, on one side is a Listilled behaviour implementation in charge of rendering its templates and on the other, it provides the necessary behavior to support its nested CellComponents . defmodule RowComponent do use Phoenix.LiveComponent alias PhoenixLiveViewExt.Listiller ######################## # Cell container related # @impl true def mount ( socket ) do { :ok , socket , temporary_assigns : [ cells : nil ] } end # Temporarily assigns the list of cell assigns for cell_components. @impl true def update ( new_assigns , socket ) do { cells , row_update } = Listiller . apply ( CellComponent , socket . assigns , new_assigns ) { :ok , socket |&gt; assign ( new_assigns ) |&gt; assign ( :cells , cells ) |&gt; assign ( :row_update , row_update ) } end #################################### # Listilled behaviour implementation # alias PhoenixLiveViewExt.Listilled @behaviour Listilled # Prepares the row dom_id list and (optionally) supplements the provided state with any # additional data required for constructing the assigns. @impl true def prepare_list ( state ) do with %{ model : model } &lt;- state do dom_ids = fetch_dom_ids ( model ) { dom_ids , state } else _ -&gt; { [ ] , state } end end # Returns dom_id as component_id @impl true def component_id ( dom_id ) , do : dom_id # Constructs new row assigns from the provided model state. @impl true def construct_assigns ( state , dom_id ) do # state-to-assigns transformations here .. %{ id : dom_id , # component id # other assigns including state required to construct the cell assigns .. } end ################## # Template helpers # import PhoenixLiveViewExt.Listilled.Helpers require PhoenixLiveViewExt.MultiRender @before_compile PhoenixLiveViewExt.MultiRender @impl true def render ( %{ updated : :delete } = assigns ) do ~L&quot;&quot;&quot; &lt;div id=&quot;row-&lt;%= @id %&gt;&quot; data-delete=&quot;true&quot;&gt;&lt;/div&gt; &quot;&quot;&quot; end def render ( assigns ) do render ( &quot;row_component_t.html&quot; , assigns ) end end Note that above we rely on the first available feature in the PhoenixLiveViewExt library v1.0.1 - the MultiRender before_compile macro that lets us define multiple (conditional) templates per LiveComponent. Also, take note that our RowComponent module imports both Distiller.Helper functions because its component's element requires post-append sorting while the template itself nests CellComponents thus requiring the phx-update attribute set relative to whether to replace or or to append the cells that have changed. Below is the relevant part of our row_component_t.html.leex template: &lt; div id = &quot;row-&lt;%= @id %&gt;&quot; data - sort = &quot;&lt;%= updated_sort( @updated) %&gt;&quot; phx - update = &quot;&lt;%= phx_update( @row_update) %&gt;&quot; phx - hook = &quot;RowHook&quot; &gt; &lt; % = for cell_assigns &lt;- @cells do % &gt; &lt; % = live_component ( @socket , CellComponent , cell_assigns ) % &gt; &lt; % end % &gt; &lt; / div &gt; As imagined, our CellComponent next is relatively simple as it has no further nested components to pass the assigns to, and all it does is implement its Listilled behaviour and renders its templates. defmodule CellComponent do alias PhoenixLiveViewExt.Listilled @behaviour Listilled # Returns cell component id based on unique cell coordinates (a row dom_id and a cell key). @impl true def component_id ( { dom_id , key } ) do &quot; \#{ dom_id } - \#{ key } &quot; end # Prepares the key list and returns it along with the state. @impl true def prepare_list ( state ) do with %{ keys : keys } &lt;- state do { Enum . map ( keys , &amp; { state . dom_id , &amp;1 } ) , state } else _ -&gt; { [ ] , state } end end # Constructs cell assigns from the provided segment state. @impl true def construct_assigns ( state , { dom_id , key } ) do # state-to-assigns transformations here .. %{ id : component_id ( { dom_id , key } ) , dom_id : dom_id , key : key , # other assigns .. } end ################## # Template helpers # import PhoenixLiveViewExt.Listilled.Helpers , only : [ updated_sort : 1 ] require PhoenixLiveViewExt.MultiRender @before_compile PhoenixLiveViewExt.MultiRender @impl true def render ( %{ updated : :delete } = assigns ) do ~L&quot;&quot;&quot; &lt;div id=&quot;cell-&lt;%= @dom_id %&gt;-&lt;%= @key %&gt;&quot; data-delete=&quot;true&quot;&gt;&lt;/div&gt; &quot;&quot;&quot; end def render ( assigns ) do render ( &quot;cell_component_t.html&quot; , assigns ) end end And the cell_component_t.html.leex template part required to operate: &lt; div id = &quot;cell-&lt;%= @dom_id %&gt;-&lt;%= @key %&gt;&quot; data - sort = &quot;&lt;%= updated_sort( @updated) %&gt;&quot; phx - hook = &quot;CellHook&quot; &gt; &lt; ! -- cell content -- &gt; &lt; / div &gt; Finally, we need some JS code to make everything work as intended. The intention of the code below is not to provide a ready-to-use, copy-paste implementation (as neither is for any of the code in this documentation), but to get a glimpse of the steps required for everything to function properly. However, the flow of invocation and the sorting algo logic should remain the same. let _sortElements = [ ] ; export const TableHook = { mounted : function ( ) { / / adding listeners this . _afterModelUpdate = e =&gt; afterModelUpdate ( this , e ) ; this . el . addEventListener ( &quot;afterModelUpdate&quot; , this . _afterModelUpdate ) ; } , destroyed : function ( ) { / / removing listeners if ( this . _afterModelUpdate ) { this . el . removeEventListener ( &quot;afterModelUpdate&quot; , this . _afterModelUpdate ) ; } } , updated : function ( ) { this . _isModelUpdated = true ; } } ; export const UpdateHook = { updated : function ( ) { const event = new Event ( &#39;afterModelUpdate&#39; ) ; document . getElementById ( &#39;table&#39; ) . dispatchEvent ( event ) ; } } ; function afterModelUpdate ( me , e ) { const isModelUpdated = me . _isModelUpdated ; me . _isModelDisabled = false ; if ( ! isModelUpdated ) return ; completeListill ( me ) ; } / * Completes the listill process by deleting all elements marked for deletion * and sorting the inserted ones . * / function completeListill ( me ) { deleteElements ( me ) ; sortElements ( ) ; } / * Iterates over the FILO element array prepared for sorting ( starting from * the last pushed one ) and repositions each of the elements found therein . * / function sortElements ( ) { _sortElements . forEach ( sort =&gt; { const src = elementById ( sort . src ) ; const dst = elementById ( sort . dst ) ; if ( src &amp;&amp; dst ) { dst . parentNode . insertBefore ( src , dst ) ; } } ) ; _sortElements = [ ] ; } / * Deletes all the elements tagged for deletion . * / function deleteElements ( src ) { src . el . querySelectorAll ( &#39;div[data-delete]&#39; ) . forEach ( el =&gt; { el . dispatchEvent ( new Event ( &#39;killListeners&#39; ) ) ; el . parentNode . removeChild ( el ) ; } ) } / * Depending on row component / element implementation , the updated callback * may or may not be needed in this Hook ; same for CellHook * / export const RowHook = { mounted : function ( ) { this . _killListeners = ( ) =&gt; { if ( this . _killListeners ) { this . el . removeEventListener ( &quot;killListeners&quot; , this . _killListeners ) ; } } ; this . el . addEventListener ( &quot;killListeners&quot; , this . _killListeners ) ; prepForSorting ( this . el , getRowSortId ) ; } , updated : function ( ) { prepForSorting ( this . el , getRowSortId ) ; } , destroyed : function ( ) { if ( this . _killListeners ) this . _killListeners ( ) ; } } ; function getRowSortId ( bareId ) { return elemId ? ( &#39;row-&#39; + bareId ) : null ; } export const CellHook = { mounted : function ( ) { this . _killListeners = ( ) =&gt; { / / remove other CellHook listeners here if ( this . _killListeners ) { this . el . removeEventListener ( &quot;killListeners&quot; , this . _killListeners ) ; } } ; this . el . addEventListener ( &quot;killListeners&quot; , this . _killListeners ) ; prepForSorting ( this . el , getCellSortId ) ; } , destroyed : function ( ) { if ( this . _killListeners ) this . _killListeners ( ) ; } } ; function getCellSortId ( bareId ) { return &#39;cell-&#39; + bareId ; } An important note: It is best advised that both sorting and deletion be done like this - in a bulk fashion all at once after all the list elements have been rendered. The attempts to do it (e.g. deletion) on element by element basis upon each element getting updated (i.e. interleaved with LiveView DOM patching) ends up in certain but relatively difficult to reproduce bugs involving inconsistent DOM state.","ref":"PhoenixLiveViewExt.Listiller.html","title":"PhoenixLiveViewExt.Listiller","type":"module"},{"doc":"Distills the assigns for the components handled by the provided module that implements Listilled behaviour. Note: Due to the lack of access to the LiveView internally held diff state and the fact that we intentionally assign constructed assigns as temporary_assigns, this function invokes PhoenixLiveViewExt.Listilled.construct_assigns/2 on both the new and the old state in every cycle. Typically, this has no significant impact on the overall performance even with tens of thousands of elements and the approach was chosen over keeping the derived transformations as (persistent) assigns to reduce memory load on the LiveView instance for it is expected that most if not all of the state supplied to the function is already kept stored with in the LiveView instance.","ref":"PhoenixLiveViewExt.Listiller.html#apply/3","title":"PhoenixLiveViewExt.Listiller.apply/3","type":"function"},{"doc":"The module provides a @before_compile macro enabling multiple template files per live component or live view. Each template file gets pre-compiled as a private render/2 function in its live component or live view module. This in turn enables (conditional) invocation from the render/1 functions. The template files should share the component or live view folder and start with their respective underscored names. In the example below we have a component that requires a different template when flagged for deletion (as part of, say, an appended container list) than the one used in the base-case scenario. defmodule MyComponent do use Phoenix.LiveComponent require PhoenixLiveViewExt.MultiRender @before_compile PhoenixLiveViewExt.MultiRender @impl true def render ( %{ delete : :true } = assigns ) do render ( &quot;my_component_delete.html&quot; , assigns ) end def render ( assigns ) do render ( &quot;my_component_enjoy.html&quot; , assigns ) end end The component folder tree may look as follows: my_app lib my_app_web live components my_component . ex my_component_delete . html . leex my_component_enjoy . html . leex .. When using MultiRender with a live view instance, there may be a function naming conflict between the MultiRender generated render/2 function and the render functions imported or used from Phoenix.View. As of version 1.1.1, the library supports providing a different name for the render/2 function by defining an otherwise optional @multi_render_fun module attribute as shown in the example below. .. require PhoenixLiveViewExt.MultiRender @multi_render_fun :prerender @before_compile PhoenixLiveViewExt.MultiRender def my_render ( assigns ) do prerender ( &quot;my_component_enjoy.html&quot; , assigns ) end .. In addition, if a different function name is specified, the MultiRender before_compile macro will no longer require a render/1 function to be present in the module, hence the above my_render/1 function name.","ref":"PhoenixLiveViewExt.MultiRender.html","title":"PhoenixLiveViewExt.MultiRender","type":"module"},{"doc":"PhoenixLiveViewExt A library of functional extensions to the Phoenix LiveView framework.","ref":"readme.html","title":"PhoenixLiveViewExt","type":"extras"},{"doc":"PhoenixLiveViewExt.MultiRender is a multi-template alternative to the Phoenix.LiveView.Renderer.render/1 macro. It pre-compiles as many template files as found collocated with and named after the live component or live view module they relate to. In other words, it allows for conditional rendering of multiple template files per live component or live view module, the functionality which is presently available in live components only if using the ~L sigil. Special credits go to José Valim for providing the instructions on how to properly approach the problem this module is solving.","ref":"readme.html#multirender","title":"PhoenixLiveViewExt - MultiRender","type":"extras"},{"doc":"Listiller (a.k.a. list distiller) handles assigns construction, diffing and pre-sorting required for an optimized use of LiveView pre/appended container lists, whether of one dimension (e.g. shopping cards, todo lists, etc.) or more nested ones (e.g. tables). With Listiller, LiveView only sends and traverses those elements in the list that have actually changed without replacing the list as a whole which has a tremendous impact on performance whether it's about just updating a single element or updating, inserting and deleting multiple elements all at the same time. Again, credits to José Valim for helping with suggestions in the brainstorming phase of this feature.","ref":"readme.html#listiller","title":"PhoenixLiveViewExt - Listiller","type":"extras"},{"doc":"This package can be installed by adding phoenix_live_view_ext to your list of dependencies in mix.exs : def deps do [ { :phoenix_live_view_ext , &quot;~&gt; 1.1.0&quot; } ] end","ref":"readme.html#installation","title":"PhoenixLiveViewExt - Installation","type":"extras"},{"doc":"The docs can be found at https://hexdocs.pm/phoenix_live_view_ext .","ref":"readme.html#docs","title":"PhoenixLiveViewExt - Docs","type":"extras"},{"doc":"Formatting The source code formatting in this library diverges from the standard formatting practice based on using mix format in that there's a leading space character inserted before all first arguments and first elements for the purpose of (subject to author's personal perception) improving the code readability.","ref":"readme.html#notes","title":"PhoenixLiveViewExt - Notes","type":"extras"}]